#include <stdio.h>

#include "dbf.h"

unsigned char *conv;

char tablename[0x100];

int
output_c (struct DBF_FIELD *field, unsigned char *buffer)
{
  int i;

  printf("\'");
  for (i=0;i<field->fieldlen && buffer[i];i++) 
      {
       if (conv)
           buffer[i] = conv[((unsigned char)buffer[i])];
       if (buffer[i] == '\'')
         printf ("\\\'"); 
       else if (buffer[i] == '\n')
         printf ("\\n"); 
         else printf ("%c", buffer[i]); 
      }
  printf("\'");
}

int
output_n (struct DBF_FIELD *field, unsigned char *buffer)
{
  int i;

  printf("\'");
  for (i=0;i<field->fieldlen;i++)
   if (isdigit(buffer[i]) || buffer[i] == '.')
         printf ("%c", buffer[i]); 
  printf("\'");
}

int
output_l (struct DBF_FIELD *field, unsigned char *buffer)
{
  printf ("\'%s\'", buffer);
}

int
output_d (struct DBF_FIELD *field, unsigned char *buffer)
{
  int i;
  int valid;

  valid=1;
  for (i=0;i<8;i++)
      if (!isdigit(buffer[i]))
        valid = 0;

  if (valid == 0)
    printf("\'1000-01-01\'");
 else  printf ("\'%c%c%c%c-%c%c-%c%c\'", 
          buffer[0], buffer[1], buffer[2], buffer[3], /* Year */ 
          buffer[4], buffer[5],  /* Month */
	  buffer[6], buffer[7]  /* Day */
  );
}

int
output_prerecord ()
{
  printf("INSERT INTO %s VALUES (", tablename);
  return 0;
}

int
output_postrecord ()
{
  printf (");\n");
  return 0;
}

int
output_fieldsep (struct DBF_FIELD *field)
{
  if (field->datatype != 'M')
    printf(",");
  return 0;
}

int output_fielddef(struct DBF_FIELD *field)
{
   if (field->datatype != 'M')
      printf ("       %s", field->name);

          switch (field->datatype)
            {
            case 'C':
              printf("  CHAR(%d)", field->fieldlen);
              break;
            case 'N':
              if (field->decimal == 0)
                 if (field->fieldlen <= 9)
                  printf("  INT(%d)", field->fieldlen);
                 else printf("  DECIMAL(%d,0)", field->fieldlen);
                else printf("  DECIMAL(%d,%d)", field->fieldlen, field->decimal);
              break;
            case 'D':
              printf("  DATE");
              break;
            case 'L':
              printf("  CHAR(1)");
              break;
	    case 'M':
	       break;
            }


   return 0;
}

int output_fielddefsep(struct DBF_FIELD *field)
{
   if (field->datatype != 'M')
     printf(",\n");
   return 0;
}


int output_dbdef(char *dbname)
{
   char *dot, *lastslash;

   lastslash = dbname;

   while (*dbname++) {
     if (*dbname == '/')
        lastslash = dbname; 
   }

   if (*lastslash == '/')
      lastslash ++;

   dot = strchr(lastslash,'.');
   if (dot == NULL)
      dot = lastslash + strlen(lastslash);
   strncpy(tablename, lastslash, dot - lastslash);
   tablename[ dot - lastslash ] = 0;

   printf("CREATE TABLE %s (\n", tablename);

   return 0;
}

int output_dbenddef()
{
   printf(");\n\n");
   return 0;
}

int
output_postdb ()
{
  printf("\n# END OF TABLE\n");
  return 0;
}


